# DATASETS

The datasets used in the experiments  

| Dataset   | N       | d   | r_i         | Data type        |
|-----------|---------|-----|-------------|------------------|
| MQ2007    | 69623   | 46  | {0,1,2}     | TF-IDF,BM25,LMIR |
| MQ2008    | 15211   | 46  | {0,1,2}     | TF-IDF,BM25,LMIR |
| Gov2003HP | 147606  | 64  | {0,1,2}     | TF-IDF,BM25,LMIR |
| Census    | 2458285 | 68  |             |                  |
| Istella   | 5308608 | 220 | {0,1,2,3,4} | BM25             |

## Download locations

Datasets locations are given below. They must be downloaded and extracted to the `raw` subdfolder

1. [LETOR 3.0](https://www.microsoft.com/en-us/research/project/letor-learning-rank-information-retrieval/#!letor-3-0):
   - Download the `Gov.rar` from [here](https://1drv.ms/u/s!Ao5ICDLaLvvAaW2uoviiYYG5lTE)
2. [LETOR 4.0](microsoft.com/en-us/research/project/letor-learning-rank-information-retrieval/#!letor-4-0):
   - Dowload the `MQ2007.rar` and `MQ2008.rar` from [here](https://1drv.ms/f/s!Aqi9ONgj3OqPaynoZZSZVfHPJd0)
3. [US 1990 Census](https://archive.ics.uci.edu/ml/datasets/US+Census+Data+(1990)):
   - Download the `USCensus1990.data.txt` from [here](https://archive.ics.uci.edu/ml/machine-learning-databases/census1990-mld/)     
4. [Istella.X](http://quickrank.isti.cnr.it/istella-dataset/):
    - Download the dataset from [here](http://quickrank.isti.cnr.it/istella-datasets-mirror/istella-X.tar.gz)

## Preprocessing

The datasets in certain cases need to be preprocessed and stored in the compressed  `.npz` format.
Please run the script [create_npz](../create_npz.py) for all the datasets before proceeding with experiments

Run this to preprocess all the raw datasets and save them.

```
python create_npz.py all --raw_data_dir ./data/raw --save_dir ./data/processed
```

Replace `all` with the name of a particular dataset to process only the selected dataset.

If you change the default locations of the processed data directory, then also remember to update the [data config file](../experiments/lambda_0_data_config.json) for the experiments

## Results

The results are separated by experiments. Each experiment is further subdivided by each dataset the experiment is run on.

1. Experiments with [lambda=0](results/lambda_0/)
2. Experiments to understand [effect of lambda](./results/lambda_query/) for each query
3. Results from [adversarial examples](results/adversarial_greedy) for greedy algorithms
4. [Subsampling](results/subsampling) results 
   