import json
import argparse
from experiments.adversarial_greedy import execute_adversarial_greedy


with open("experiments/adversarial_greedy_alg_config.json", "r") as fp:
    alg_dict = json.load(fp)


def get_args():
    parser = argparse.ArgumentParser(
        description="Collect results for Adversarial example"
    )
    parser.add_argument(
        "algorithm",
        type=str,
        help="The algorithm to run with adversarial example",
        choices=alg_dict.keys(),
    )
    parser.add_argument("--N", type=int, default=100, help="Total number of items")
    parser.add_argument(
        "--bad_examples", type=int, default=5, help="Number of adversarial items"
    )
    parser.add_argument("--repetitions", type=int, default=10, help="Times to repeat ")
    parser.add_argument(
        "--lambdas", type=float, nargs="+", default=[0.01, 1], help="Values of lambda"
    )
    parser.add_argument(
        "--overwrite_mode",
        type=str,
        default="None",
        help="Whether to overwrite or append results",
        choices=["None", "overwrite", "append"],
    )

    args = parser.parse_args()
    return args


if __name__ == "__main__":
    args = get_args()

    execute_adversarial_greedy(
        args, alg_dict[args.algorithm], overwrite_mode=args.overwrite_mode
    )

