import json
import argparse
import multiprocessing as mp
from experiments.lambda_0 import execute_lambda_0


with open("experiments/lambda_0_alg_config.json",'r') as fp:
    alg_dict = json.load(fp)
with open("experiments/lambda_0_data_config.json",'r') as fp:
    data_dict = json.load(fp)

def get_args():
    parser = argparse.ArgumentParser(
        description="Collect results for lambda=0 experiment"
    )
    parser.add_argument(
        "algorithm",
        type=str,
        help="The algorithm to run",
        choices=alg_dict.keys(),
    )
    parser.add_argument(
        "dataset",
        type=str,
        help="The dataset to use",
        choices=data_dict.keys()
    )
    parser.add_argument(
        "--num_processes",
        type=int,
        default=mp.cpu_count(),
        help="How many processes to use"
    )
    parser.add_argument(
        "--overwrite_mode",
        type=str,
        default="None",
        help="Whether to overwrite or append results",
        choices=["None", "overwrite", "append"],
    )

    args = parser.parse_args()
    return args

#%%
if __name__ == "__main__":
        
    args = get_args()
    execute_lambda_0(args,data_dict[args.dataset],alg_dict[args.algorithm],overwrite_mode=args.overwrite_mode)

# %%
