#%%
# %load_ext autoreload
# %autoreload 2
import json
import argparse
import numpy as np
from experiments.lambda_query import execute_lambda_query
    
with open("experiments/lambda_query_alg_config.json",'r') as fp:
    alg_dict = json.load(fp)
with open("experiments/lambda_query_data_config.json",'r') as fp:
    data_dict = json.load(fp)

def get_args():
    parser = argparse.ArgumentParser(
        description="Collect results for lambda query experiment"
    )
    parser.add_argument(
        "algorithm",
        type=str,
        help="The algorithm to run",
        choices=alg_dict.keys(),
    )
    parser.add_argument(
        "dataset",
        type=str,
        help="The dataset to use",
        choices=data_dict.keys()
    )
    parser.add_argument(
        "--lambdas",
        type=float,
        nargs="+",
        default=np.arange(0,1.4,0.2),
        help="The values of lambda"
    )
    parser.add_argument(
        "--overwrite_mode",
        type=str,
        default="None",
        help="Whether to overwrite or append results",
        choices=["None", "overwrite", "append"],
    )

    args = parser.parse_args()
    return args

#%%
if __name__ == "__main__":
    args = get_args()
    execute_lambda_query(args,data_dict[args.dataset],alg_dict=alg_dict[args.algorithm],overwrite_mode=args.overwrite_mode)